def compute_instance_scores(dataset $\dataset$, contexts $\contexts$, typical behaviors $\behaviors$, context scores $\cscores$, instance inhibition $\gamma_{\delta}$):
    for $\instance \in \dataset$:
        $r = \relevantctxt$
        $I = \{\civotebl | \ctxt \in r \land \cscore \in \cscores \land \omega_j \in \behaviors\}$
        $\iscore$ = noisy_or($I, \gamma_{\delta}$)
        $\Delta = \iscores \cup \{\iscore\}$
    return instance scores $\iscores$
    
def compute_context_scores(dataset $\dataset$, contexts $\contexts$, instance scores $\iscores$, context inhibition $\gamma_{\lambda}$):
    for $\ctxt \in \contexts$:
        $r = \relevantinst$
        $I = \{1-\iscore | \instance \in r \land \iscore \in \iscores\}$
        $\cscore$ = 1 - noisy_or($I, \gamma_{\lambda}$)
        $\cscores = \cscores \cup \{\cscore\}$ 
    return context scores $\cscores$
    
def noisy_or($I, \gamma$):
    return $1 - \prod_{i \in I} (1 - i \cdot \gamma)$