# phase 1: discover contexts
for $i=1, \ldots, |\attributes|$:
    $T_i$ = learn_tree($\dataset$, inputs=$\attributes \setminus \{A_i\}$, outputs=$\{A_i\}$)
let $l_j$ denote leaf $j$ (numbered consecutively throughout ensemble)
let $c_j$ denote the set of instances covered by $l_j$

# phase 2: model typical behavior
for each leaf $l_j$:
    $\parent =\texttt{get\_ancestor\_with\_lowest\_impurity}(l_j)$
    if impurity($l_j$) > impurity($\parent$):
        $\kde = \texttt{do\_kde}(p_j)$
    else:
        $\kde = \texttt{do\_kde}(l_j)$
    $\omega_j$ = normalize_kde($\kde, \squashparameter$) # function $\omega_j$ from Eq. 1

# phase 3: estimate instance and leaf abnormalities
$\boldsymbol{\lambda} = \boldsymbol{0}$ # Initially, every context is considered normal
for $\_$ in range($n$):
    for all $i$, $j$ where $x_i\in c_j$: $v_{ij} = \lambda_j + (1-\lambda_j) (1-\omega_j({x_i}))$
    for all $i$: $\delta_i = \noisyor{ \{v_{ij} | x_i \in c_j\}; \gamma_\delta}$
    for all $j$: $\lambda_j = 1-\noisyor{\{1-\delta_i | x_i \in c_j)\}; \gamma_\lambda}$
